% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Movement_calcs.R
\name{CalcAsymptoticDist}
\alias{CalcAsymptoticDist}
\title{Calculates the asymptotic distribution from an initial distribution vector (V) and a markov movement matrix (M) (rows sum to 1)}
\usage{
CalcAsymptoticDist(M, V = NULL, nits = 50, plot = F)
}
\arguments{
\item{M}{A square markov movement matrix M of nareas rows and nareas columns (rows sum to 1)}

\item{V}{An optional vector nareas long of initial fractions by area (if unspecified the calculation will start from a uniform distribution)}

\item{nits}{An integer number of iterations for multiplying V by M to get the asymptotic distribution (~50 is usually enough)}

\item{plot}{Should the convergence to a stable distribution be plotted?}
}
\description{
Calculates the asymptotic distribution from an initial distribution vector (V) and a markov movement matrix (M) (rows sum to 1).
}
\seealso{
\link{simmov2}
}
\author{
T. Carruthers
}
\keyword{internal}
