% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Misc_Exported.R
\name{avail}
\alias{avail}
\title{What objects of this class are available}
\usage{
avail(classy, package = NULL, msg = TRUE, abc = FALSE)
}
\arguments{
\item{classy}{A class of object (character string, e.g. 'Fleet')}

\item{package}{Optional. Names(s) of the package to search for object of class \code{classy}. String
Default is all \code{openMSE} packages. Always searches the global environment as well.}

\item{msg}{Print messages?}

\item{abc}{Logical, whether to alphabetize the results. By default, the function returns results found in
the global environment, then core openMSE packages, and any additional packages in argument \code{package}.}
}
\description{
Generic class finder
}
\details{
Finds objects of the specified class in the global environment or the
openMSE packages.
}
\examples{
avail("OM", msg=FALSE)
Stocks <- avail("Stock")
Fleets <- avail("Fleet")
MPs <- avail("MP")
}
\seealso{
\link{Can} \link{Cant} \link{avail}
}
\author{
T. Carruthers
}
